//+------------------------------------------------------------------+ 
//|   TRO_SLINGSHOT                                                  | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window
#property indicator_buffers 0


extern bool UseTradingTimes = True;
extern int HourStart = 7;
extern int HourEnd = 20;
extern double Lots = 0;
extern bool MoneyManagement = False;
extern int Risk = 0;
extern int Slippage = 5;
extern  bool UseStopLoss = True;
extern bool OverRideStopLoss = False;
extern int StopLoss = 100;
extern bool UseTakeProfit = False;
extern bool OverRideTakeProfit = False;
extern int TakeProfit = 60;
extern bool UseTrailingStop = False;
extern int TrailingStop = 30;
extern bool MoveStopOnce = False;
extern int MoveStopWhenPrice = 50;
extern int MoveStopTo = 1;
extern string Remark2 = "";
extern string Remark3 = "== SlingShot Settings ==";
extern int MinRange = 150;
extern int PipBuffer = 10;
extern int MaxTradesPerBar = 1;



datetime tTime ;  
int    elapsed ,period ;  
string symbol ;

double PROFITLOSS;


double LongEntry;
double ShortEntry;

int EntryBar;
int SignalBar;
int BarsCount;
int RemainingTrades;
//Version 2.01

int OpenBarCount;
int CloseBarCount;

int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
int init()
  {
   symbol = Symbol() ;
   period = Period() ;
   tTime        = 0 ;
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {


   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+



int Spread = MathAbs( (Bid - Ask) / Point);

double PreviousClose = iClose(NULL, 0, 1);
double PreviousHigh = iHigh(NULL, 0, 1);
double PreviousLow = iLow(NULL, 0, 1);

double CurrentClose = iClose(NULL, 0, 0);
double CurrentHigh = iHigh(NULL, 0, 0);
double CurrentLow = iLow(NULL, 0, 0);

//check range
string Range = "Too Small";
if(PreviousHigh - PreviousLow > MinRange * Point) Range = "Large Enough";   

if(BarsCount != Bars) {
   RemainingTrades = MaxTradesPerBar;
   ShortEntry = 0;
   LongEntry = 0;
   BarsCount = Bars;
   }
   
if( CurrentClose > PreviousHigh && RemainingTrades > 0) {
   ShortEntry = PreviousClose - (PipBuffer * Point);
   LongEntry = 0;
   }
   
if( CurrentClose < PreviousLow && RemainingTrades > 0) {
   LongEntry = PreviousClose + (PipBuffer * Point);
   ShortEntry = 0;
   }   

string TradingTimes = "Outside Trading Times"; 
if(UseTradingTimes && TimeHour(TimeCurrent()) >= HourStart && TimeHour(TimeCurrent()) < HourEnd) TradingTimes = "Inside Trading Times";
if(!UseTradingTimes) TradingTimes = "Not Used";     


   
string TradeTrigger = "None";
if(LongEntry != 0 && CurrentClose >= LongEntry && RemainingTrades > 0 && (TradingTimes == "Inside Trading Times" || TradingTimes == "Not Used") ) {
   TradeTrigger = "Open Long";
   PROFITLOSS   = CurrentClose - LongEntry ;
   EntryBar = Bars;
   }
   
if(ShortEntry != 0 && CurrentClose <= ShortEntry && RemainingTrades > 0 && (TradingTimes == "Inside Trading Times" || TradingTimes == "Not Used") ) {
   TradeTrigger = "Open Short"; 
   PROFITLOSS   = ShortEntry - CurrentClose ;     
   EntryBar = Bars;
   }

string CloseTrigger = "None";
if(EntryBar != Bars) CloseTrigger = "Close All";


Comment("Current Time: ", TimeHour(TimeCurrent()), ":", TimeMinute(TimeCurrent()), "\n",
        "Range Status: ", Range, "\n",
        "Long Entry Price: ", LongEntry, "\n",
        "Short Entry Price: ", ShortEntry, "\n",
        "Trading Times: ", TradingTimes, "\n",
        "Remaining Trades: ", RemainingTrades, "\n",
        "Trade Trigger: ", TradeTrigger, "\n",
        "PROFIT/LOSS:   ", DoubleToStr( PROFITLOSS , 5) , "\n",        
        "Close Trigger: ", CloseTrigger);   

           
   return(0);
}
//+------------------------------------------------------------------+

/*
string sTimeCurrent = TimeToStr(TimeCurrent(),TIME_SECONDS); // server time
string sTimeLocal   = TimeToStr(TimeLocal(),TIME_SECONDS);   // local computer time
string sTimeBar     = TimeToStr(Time[0],TIME_SECONDS);    // current bar time

*/